<?php

/**
 * template name: 用户中心(/user)
 */
date_default_timezone_set('Asia/Shanghai');
if(!is_user_logged_in() || !is_site_shop_open()){
	header("Location:".home_url());
	exit();
}
global $current_user;
$part_action = (isset($_GET['action'])) ? strtolower($_GET['action']) : '' ;
?>
<!DOCTYPE html>
<html <?php language_attributes(); ?>>
<head>
	<meta charset="<?php bloginfo( 'charset' ); ?>">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="profile" href="https://gmpg.org/xfn/11">
	<link href="<?php echo _cao('site_favicon') ?>" rel="icon">
  <title><?php echo _title() ?></title>

	<?php wp_head(); ?>
	<!-- HTML5 shim, for IE6-8 support of HTML5 elements. All other JS at the end of file. -->
    <!--[if lt IE 9]>
      <script src="<?php echo get_stylesheet_directory_uri() ?>/assets/js/html5shiv.js"></script>
      <script src="<?php echo get_stylesheet_directory_uri() ?>/assets/js/respond.min.js"></script>
    <![endif]-->
     <script src="//at.alicdn.com/t/font_1169726_u1uoi1l1g9q.js"></script>
     <link rel='stylesheet' href='//at.alicdn.com/t/font_1575172_o74aqw4vxeb.css' type='text/css' />
</head>

<body <?php body_class(); ?> style=" background-color: #fff; ">

<div class="site">
    <?php
        get_template_part( 'parts/navbar' );
    ?>
    
<div class="site-content" style="padding-top: 0px;">
	
<div class="term-bar visible lazyloaded" style="height:328px; background-image:url(https://www.wzzti.com/user.jpg);background-size: cover;background-repeat: no-repeat;background-position: 15% 15%;background-color: rgba(0, 0, 0, 0.2);text-align:left;display:block">
	<div class="container">
		<div class="apollo-user-meta py-4 mt-4 mt-md-5">
	    	<div class="user-d-flex">
	        	<div class="mb-3 mb-md-0">
		            <div class="flex-avatar w-96 rounded">
		            	<?php echo get_avatar($current_user->user_email); ?>
		            </div>
	        	</div>
		        <div class="text-white mx-md-4 flex-fill">
		            <div class="name text-lg"><span class=""></span><?php echo $current_user->display_name;?> 
		                <?php 
		                global $current_user;
						$CaoUser = new CaoUser($current_user->ID);
			                if ($CaoUser->vip_status()) {
			                	echo '<span class="wp wp-VIP"><i class="fa fa-diamond"></i> '.$CaoUser->vip_name().'用户</span>';
			                	echo '<div class="data mt-2"><span class="mr-3"><span class="font-theme text-lg text-white">'.$CaoUser->vip_end_time().'</span><small class=" text-xs text-light mx-1">  会员到期</small></span></div>  ';
			                }else{
			                	echo '<span class="wp wp-VIP"><i class="fa fa-user"></i> '.$CaoUser->vip_name().'用户</span>';
			                	echo '<div class="data mt-2"><span class="mr-3"><span class="font-theme text-lg text-white">'.$CaoUser->vip_end_time().'</span><small class=" text-xs text-light mx-1">  暂无特权</small></span></div>  ';
			                }
		                ?>
		        	</div>
		    	</div>
			</div>		
		</div>
	</div>
</div>
<div class="lang"><div class="lang__3"></div><div class="lang__4"></div></div>

<?php get_template_part( 'pages/user/header');?>


<!-- #user-profile
============================================= -->

<div class="container">
    <section id="user-profile" class="user-profile">
        <div class="row">
            <?php
            if ($part_action != 'addproduct') {
               get_template_part( 'pages/user/nav');
            }?>
            <!-- .col-md-4 -->
            <?php
	            if ($part_action) {
					get_template_part( 'pages/user/'.$part_action);
				}else{
					get_template_part( 'pages/user/index');
				}
			?>
            
        </div>
    </section>
</div>
<!-- #user-profile  end -->



<?php get_footer(); ?>